#include <fstream.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <time.h>
#include <graphics.h>

int W, LOW, HIGH;
long M = 1;

class block {
    int size, x, y;
    void *image;
  public:
    block *next;
    block(int x, int y, int size);
    ~block();
    void move(int new_x, int new_y);
    void draw();
};

class core {
    block *beg;
    int x, w;
  public:
    core(int x, int N);
    ~core();
    void add_block(block *b);
    block *delete_block();
    int get_free_y();
    void draw();
};

block::block(int x, int y, int size)
{
  block::x = x;
  block::y = y;
  block::size = size;
  unsigned s = imagesize(0, 0, size * W * 2, W);
  image = (void *)(new char[s]);
  getimage(x - size * W, y, x + size * W, y + W - 1, image);
  draw();
}

block::~block()
{
  delete image;
}

void block::move(int new_x, int new_y)
{
  while (y > HIGH - W * 2)
  {
    putimage(x - size * W, y, image, COPY_PUT);
    y--;
    getimage(x - size * W, y, x + size * W, y + W - 1, image);
    delay(1);
    draw();
  }
  while (x != new_x)
  {
    setcolor(0);
    if (new_x - x < 0)
    {
      line(x + size * W, y, x + size * W, y + W - 1);
      x--;
    }
    else
    {
      line(x - size * W, y, x - size * W, y + W - 1);
      x++;
    }
    delay(1);
    draw();
  }
  while (y < new_y)
  {
    putimage(x - size * W, y, image, COPY_PUT);
    y++;
    getimage(x - size * W, y, x + size * W, y + W - 1, image);
    delay(1);
    draw();
  }
}

void quit()
{
  getch();
  closegraph();
  exit(0);
}

void block::draw()
{
  if (kbhit()) quit();
  setcolor(15);
  rectangle(x - size * W, y, x + size * W, y + W - 1);
  setfillstyle(1, 1);
  bar(x - size * W + 1, y + 1, x + size * W - 1, y + W - 2);
}

core::core(int x, int N)
{
  beg = NULL;
  core::x = x;
  w = (N + 1) * W;
  draw();
}

void core::add_block(block *b)
{
  b -> next = beg;
  int y = get_free_y();
  b -> move(x, y);
  beg = b;
}

block *core::delete_block()
{
  block *b = beg;
  beg = beg -> next;
  return b;
}

int core::get_free_y()
{
  block *b = beg;
  int y = 0;

  while (b)
  {
    y += W;
    b = b -> next;
  }

  return LOW - y - W;
}

void core::draw()
{
  setcolor(15);
  line(x - w, LOW, x + w, LOW);
  rectangle(x - 3, HIGH, x + 3, LOW);
}

core::~core()
{
  block *b = beg;

  while (beg)
  {
    beg = b -> next;
    delete b;
    b = beg;
  }
}

void Move(core *X, core *Y)
{
  gotoxy(1, 1);
  cout << "Move " << M++;
  Y -> add_block(X -> delete_block());
}

void H(int N, core *X, core *Y, core *Z)
{
  if (N > 1)
  {
    H(N - 1, X, Z, Y);
    Move(X, Y);
    H(N - 1, Z, Y, X);
  }
  else
    Move(X, Y);
}

void main(int argc, char **argv)
{
  int N = 4, gd = EGA, gm = 1;
  if (argc > 1) N = atoi(argv[1]);

  if ((N < 1) || (N > 14))
  {
    cout << "᫮    1  12\n";
    return;
  }

  registerbgidriver(EGAVGA_driver);
  initgraph(&gd, &gm, "");
  if ((int)graphresult != grOk && (int)graphresult != 781)
  {
    cout << "訡 樠樨 䨪\n";
    return;
  }

  W = (getmaxx() - 20) / (6 * (N + 1));

  LOW = getmaxy() / 2 + W * (N / 2 + 1);
  HIGH = getmaxy() / 2 - W * (N / 2 + 1);

  core a(getmaxx() / 2 - 10 - (N + 1) * W * 2, N),
       b(getmaxx() / 2, N),
       c(getmaxx() / 2 + 10 + (N + 1) * W * 2, N);

  for (int i = 0; i < N; i++)
  {
    block *b = new block(getmaxx() / 2, 0, N - i);
    a.add_block(b);
  }

  H(N, &a, &b, &c);
  gotoxy(1, 1);
  cout << "Sorting completed";

  quit();
}

